    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------------------
    028     * StandardCategoryToolTipGenerator.java
    029     * -------------------------------------
    030     * (C) Copyright 2004-2006, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: StandardCategoryToolTipGenerator.java,v 1.3.2.3 2006/08/04 11:47:49 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 11-May-2004 : Version 1 (DG);
    040     * ------------- JFREECHART 1.0.0 ---------------------------------------------
    041     * 03-May-2006 : Added equals() method to fix bug 1481087 (DG);
    042     *
    043     */
    044
    045    package org.jfree.chart.labels;
    046
    047    import java.io.Serializable;
    048    import java.text.DateFormat;
    049    import java.text.NumberFormat;
    050
    051    import org.jfree.data.category.CategoryDataset;
    052
    053    /**
    054     * A standard tool tip generator that can be used with a
    055     * {@link org.jfree.chart.renderer.category.CategoryItemRenderer}.
    056     */
    057    public class StandardCategoryToolTipGenerator
    058        extends AbstractCategoryItemLabelGenerator
    059        implements CategoryToolTipGenerator, Serializable {
    060
    061        /** For serialization. */
    062        private static final long serialVersionUID = -6768806592218710764L;
    063
    064        /** The default format string. */
    065        public static final String DEFAULT_TOOL_TIP_FORMAT_STRING
    066            = "({0}, {1}) = {2}";
    067
    068        /**
    069         * Creates a new generator with a default number formatter.
    070         */
    071        public StandardCategoryToolTipGenerator() {
    072            super(DEFAULT_TOOL_TIP_FORMAT_STRING, NumberFormat.getInstance());
    073        }
    074
    075        /**
    076         * Creates a new generator with the specified number formatter.
    077         *
    078         * @param labelFormat  the label format string (<code>null</code> not
    079         *                     permitted).
    080         * @param formatter  the number formatter (<code>null</code> not permitted).
    081         */
    082        public StandardCategoryToolTipGenerator(String labelFormat,
    083                                                NumberFormat formatter) {
    084            super(labelFormat, formatter);
    085        }
    086
    087        /**
    088         * Creates a new generator with the specified date formatter.
    089         *
    090         * @param labelFormat  the label format string (<code>null</code> not
    091         *                     permitted).
    092         * @param formatter  the date formatter (<code>null</code> not permitted).
    093         */
    094        public StandardCategoryToolTipGenerator(String labelFormat,
    095                                                DateFormat formatter) {
    096            super(labelFormat, formatter);
    097        }
    098
    099        /**
    100         * Generates the tool tip text for an item in a dataset.  Note: in the
    101         * current dataset implementation, each row is a series, and each column
    102         * contains values for a particular category.
    103         *
    104         * @param dataset  the dataset (<code>null</code> not permitted).
    105         * @param row  the row index (zero-based).
    106         * @param column  the column index (zero-based).
    107         *
    108         * @return The tooltip text (possibly <code>null</code>).
    109         */
    110        public String generateToolTip(CategoryDataset dataset,
    111                                      int row, int column) {
    112            return generateLabelString(dataset, row, column);
    113        }
    114
    115        /**
    116         * Tests this generator for equality with an arbitrary object.
    117         *
    118         * @param obj  the object (<code>null</code> permitted).
    119         *
    120         * @return A boolean.
    121         */
    122        public boolean equals(Object obj) {
    123            if (obj == this) {
    124                return true;
    125            }
    126            if (!(obj instanceof StandardCategoryToolTipGenerator)) {
    127                return false;
    128            }
    129            return super.equals(obj);
    130        }
    131
    132    }